import com.urbancode.air.CommandHelper;
import com.urbancode.air.AirPluginTool;

final def workDir = new File('.').canonicalFile

def apTool = new AirPluginTool(this.args[0], this.args[1]) //assuming that args[0] is input props file and args[1] is output props file
def props = apTool.getStepProperties();

def scriptBody = props['scriptBody']
def commandPath = props['commandPath'] != ("") ? props['commandPath'] : ""

def inputPropsFile = new File(args[0])
def outputPropsFile = new File(args[1])

CommandHelper ch = new CommandHelper(workDir)
ch.ignoreExitValue(true)

//create the script, set it to delete when the step exits, create it and clear it just in case there was somehow some data there.
def curTime = System.currentTimeMillis()
def scriptData = new File("Script${curTime}.ps1")
scriptData.deleteOnExit()
scriptData.createNewFile()
scriptData.write("")
scriptData.write(scriptBody)

def cmdArgs = []

if (!commandPath.equals("")) {
    commandPath.trim()
    
    while (commandPath.endsWith("\\")) {
        commandPath = commandPath.substring(0, commandPath.length-1)
    }
    
    cmdArgs << commandPath + File.separator + "powershell.exe"
}

else {
    cmdArgs << "powershell.exe"
}

cmdArgs << ";" << "set-executionpolicy unrestricted" << ";" 
cmdArgs << scriptData.absolutePath << inputPropsFile.absolutePath << outputPropsFile.absolutePath

def exitCode = ch.runCommand("Running Powershell script", cmdArgs)


if (exitCode != 0) {
    println "Failed to execute script."
    System.exit(exitCode)
}
else {
    println "Script executed successfully."
    System.exit(0)
}